doctype html
html
	head
		title Couchbase Monitor
		meta(name="viewport", content="width=device-width, initial-scale=1, shrink-to-fit=no")
		link(rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta/css/bootstrap.min.css")
		script(src="https://code.jquery.com/jquery-3.2.1.min.js")
		script(src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.4.2/vue.js")
		script(src="https://cdnjs.cloudflare.com/ajax/libs/d3/4.10.0/d3.min.js")
	body
		div#app
			nav.navbar.navbar-expand-lg.navbar-light.bg-light
				a.navbar-brand(href="#") CB Mon
				div#navbarcontent.collapse.navbar-collapse
					ul.navbar-nav.mr-auto
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='stats'") Stats
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='indexes'") Indexes
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='queryHistory'") Query History
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='logs'") Logs
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='summary'") Summary
						li.nav-item
							a.nav-link(href="#" v-on:click="currentPanel='visualize'") Visualize
					form.form-inline
						button.btn.btn-outline-success(v-on:click="test(true)") Start Test
						span &nbsp;
						button.btn.btn-outline-warning(v-on:click="test(false)") Stop Test
			div.container.container-fluid
				div.row
					div.col-12
						h2 Session Control
						button.btn.btn-info(v-on:click="snapshot('Compactation')") Compactation
						span &nbsp;
						button.btn.btn-primary(v-on:click="snapshot('Indexing')") Indexing
						hr
				div.row(v-if="currentPanel=='stats'")
					div.col-12
						h3 Servers
						table.table
							tr
								th Host
								th Roles
								th CPU %
								th Memory (Gb)
								th Items
								th Ops
								th Get hits
								th Status
								th OS
								th Uptime
							tr(v-for="server in servers")
								td 
									small {{ server.host }}
								td 
									small {{ server.roles.join(', ') }}
								td 
									small {{ server.cpu | round }}
								td
									small {{ (server.mem - server.memFree) | toGb | round }} / {{ server.mem | toGb | round }}
								td
									small {{ server.items }}
								td
									small {{ server.ops }}
								td
									small {{ server.gethits }}
								td
									small {{ server.status }}
								td 
									small {{ server.os }}
								td
									small {{ Math.trunc(server.uptime / 60) }} min
					div.col-12
						h3 Query Nodes {{ querystats.length }}
						table.table
							tr
								th Node
								th Threads
								th Cores
								th GC Pause
								th Completed
								th Active
								th R/min
								th R/5 min
								th R mean
								th R median
							tr(v-for="stats in querystats")
								td {{ stats.node }}
								td {{ stats["total.threads"] }}
								td {{ stats.cores }}
								td {{ stats["gc.pause.time"] }}
								td {{ stats["request.completed.count"] | round }}
								td {{ stats["request.active.count"] }}
								td {{ stats["request.per.sec.1min"] }}
								td {{ stats["request.per.sec.5min"] }}
								td {{ stats["request_time.mean"] }}
								td {{ stats["request_time.median"] }}
					div.col-12
						h3 Stats
						table.table
							tr
								th Bucket
								th Type
								th Documents
								th Ops/sec
							tr(v-for="s in stats")
								td {{ s.name }}
								td {{ s.bucketType }}
								td {{ s.basicStats.itemCount | round }}
								td {{ s.basicStats.opsPerSec | round}}
					div.col-12
						h3 Active Queries {{ activeQueries.length }}
						table.table
							tr
								th Query
								th Elapsed
								th Execution
								th Scan Consistency
							tr(v-for="query in activeQueries")
								td {{ query.statement }}
								td {{ query.elapsedTime }}
								td {{ query.executionTime }}
								td {{ query.scanConsistency }}
				div.row(v-if="currentPanel=='logs'")
					div.col-md-12
						h3 Logs
						table.table
							tr
								th Date
								th Entry
							tr(v-for="entry in log")
								td {{ entry.ts }}
								td {{ entry.message }}
				div.row(v-if="currentPanel=='queryHistory'")
					div.col-md-12
						h3 Query History {{ queryHistory.length }}
						table.table
							tr
								th Query
								th Elapsed
								th Execution
								th Scan Consistency
							tr(v-for="query in queryHistory")
								td {{ query.statement }}
								td {{ query.elapsedTime }}
								td {{ query.executionTime }}
								td {{ query.scanConsistency }}
				div.row(v-if="currentPanel=='indexes'")
					div.col-12
						h3 Indexes 
						table.table
							tr
								th id
								th Bucket
								th Index
								th Status
								th Definition
								th Progress
								th Hosts
							tr(v-for="index in indexes")
								td
									small {{ index.id }}
								td
									small {{ index.bucket }}
								td
									small {{ index.index }}
								td
									small {{ index.status }}
								td
									small {{ index.definition }}
								td
									small {{ index.progress }}
								td
									small {{ index.hosts.join(', ') }}
				div.row(v-if="currentPanel=='summary'")
					div.col-md-12
						h3 Summary
						div
							strong Total Nodes: &nbsp;
							span.text-info {{ servers.length }}
						div
							strong Data Nodes: &nbsp;
							span.text-info {{ servers.filter((node)=>node.roles.includes('Data')).length }}
						div
							strong Query Nodes: &nbsp;
							span.text-info {{ servers.filter((node)=>node.roles.includes('Query')).length }}
						div
							strong Index Nodes: &nbsp;
							span.text-info {{ servers.filter((node)=>node.roles.includes('Index')).length }}
						div
							strong Indexes: &nbsp;
							span.text-info {{ indexes.length }}
						div
							strong Session ID: &nbsp;
							span.text-info {{ sessionId }}
				div.row(v-if="currentPanel=='visualize'")
					div.col-md-12
						
						h3 Query Nodes Performance
						div#chart-query
							//- svg(width="960" height="500")
						div resources, data growth, ops growth, query growth
		script(src="js/chart.js")
		script(src="js/stats.js")